Given an arraySofnintegers, are there elementsa,b,cinSsuch thata+b+c= 0? Find all unique triplets in the array which gives the sum of zero.

**Note:**The solution set must not contain duplicate triplets.

```
For example, given array S = [-1, 0, 1, 2, -1, -4],

A solution set is:
[
  [-1, 0, 1],
  [-1, -1, 2]
]
```

**Thoughts: **

a + b + c =0 &lt;=&gt; a + b = -c

Traverse each element : a target of two sum. Search direction should be consistent with the direction of traverse order\(avoid duplicates\).

**\[code 1: using map\]: O\(n^2\) + Extra Space \(unordered\_map\)**

```cpp
class Solution {
   vector<vector<int>> answer; 
public:
    vector<vector<int>> threeSum(vector<int>& nums) {
        if (nums.size() < 3) return answer;

        // sort the vector so that it avoids duplicates 
        sort(nums.begin(), nums.end()); // sort 不sort 无所谓

        // for (auto i = nums.begin(); i != nums.end(); ++i)
        //     std::cout << *i << ' ';
        for (int i = 0; i < nums.size(); i++){

            int target = -nums[i];
            vector<int>::const_iterator first = nums.begin()+ i + 1;
            vector<int>::const_iterator last = nums.end();
            vector<int> subNums(first, last);
            // two sum to find target

            twoSum(subNums, target);
            // answer.insert(answer.end(), result.begin(), result.end());
            while(i<nums.size()-1 && nums[i] == nums[i+1]) i++; // add here to speed up duplicates, 
            //this line must be added after calling twoSum... 
        }
            // remove duplicates
            set<vector<int>> s( answer.begin(), answer.end() );
            answer.assign( s.begin(), s.end() );

        return answer;
    }

private:
    void twoSum (vector<int>& nums, int target){
        if(nums.size()==0) return;
        map.clear();
        for(int i= 0; i< nums.size(); ++i){
            int res = target - nums[i];
            if(map.find(res)!=map.end()){
                vector<int> solution= {-target, res, nums[i]};
                answer.push_back(solution);
            }
            else map[nums[i]] = i;
        }
    }

    unordered_map<int,int> map;
};
```

**\[code 2: **[**two pointer**](http://bangbingsyb.blogspot.com/2014/11/leetcode-3sum.html)**\]:** **O\(n^2\) without extra space \(ordered\_map\)**

There are two

```cpp
class Solution {
    vector<vector<int>>answer;
public:
    vector<vector<int>> threeSum(vector<int>& nums) {
        int len = nums.size();
        if (len < 3) return answer;

        // sort the vector
        sort(nums.begin(), nums.end());

        for(int i = 0; i < len; i++){

            int left = i + 1, right = len - 1, target = -nums[i];

            // treat as two sum using two pointers
            while(left < right){
            // speed up two sum runtime by removing two sum search for duplicated target value 
            while(i > 0 && nums[i] == nums[i-1]) i++; 
            // alternatively, you can write :
            // if(i>0 && nums[i] == nums[i-1]) continue;
            //at the beginning of the for loop


                int sum = nums[left] + nums[right];
                if( sum == target){
                    answer.push_back({-target,nums[left],nums[right]});
                    // speed up two sum search runtime by removing duplicates 
                    left++;
                    right--;
                    while(left < right && nums[left] == nums[left-1]) left++; // you may not need "left<right"
                    //here in C++

                    while(left < right && nums[right] == nums[right+1])right--; // you may not need "left<right" 
                    //here in C++


                }
                else if (sum < target){
                    left ++;
                }
                else{
                    right--;
                }

            }

        }

        return answer;
    }
};
```

**Variation: Expand sum to be 0 as in general case**

```cpp
class Solution {
    vector<vector<int>>answer;
public:
    vector<vector<int>> threeSum(vector<int>& nums, int target) {
        int len = nums.size();
        if (len < 3) return answer;

        // sort the vector
        sort(nums.begin(), nums.end());

        for(int i = 0; i < len; i++){

            int left = i + 1, right = len - 1, twoSumTarget = target - nums[i]; // THE ONLY DIFFERENCE!

            // treat as two sum using two pointers
            while(left < right){
            // speed up two sum runtime by removing two sum search for duplicated target value 
            // while(i > 0 && nums[i] == nums[i-1]) i++; 
            // alternatively, you can write :
            if(i>0 && nums[i] == nums[i-1]) continue;
            //at the beginning of the for loop


                int sum = nums[left] + nums[right];
                if( sum == twoSumTarget ){
                    answer.push_back({nums[i], nums[left],nums[right]});
                    // speed up two sum search runtime by removing duplicates 
                    left++;
                    right--;
                    while(left < right && nums[left] == nums[left-1]) left++; // you may not need "left<right"
                    //here in C++

                    while(left < right && nums[right] == nums[right+1])right--; // you may not need "left<right" 
                    //here in C++


                }
                else if (sum < twoSumTarget ){
                    left ++;
                }
                else{
                    right--;
                }

            }

        }

        return answer;
    }
};
```

Special thanks: [洗刷刷](http://bangbingsyb.blogspot.com/2014/11/leetcode-3sum.html) for the reference!

