# 236. Lowest Common Ancestor of a Binary Tree

Given a binary tree, find the lowest common ancestor \(LCA\) of two given nodes in the tree.

According to the[definition of LCA on Wikipedia](https://en.wikipedia.org/wiki/Lowest_common_ancestor): “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants \(where we allow**a node to be a descendant of itself**\).”        \_\_\_\_\_\_\_3\_\_\_\_\_\_

```
       /              \
    ___5__          ___1__
   /      \        /      \
   6      _2       0       8
         /  \
         7   4
```

For example, the lowest common ancestor \(LCA\) of nodes`5`and`1`is`3`. Another example is LCA of nodes`5`and`4`is`5`, since a node can be a descendant of itself according to the LCA definition.

**Thoughts:**

Recursion: for each node, there must be three cases {left, right, root} that contains CLA.

**Code \(C++\)**

```cpp
/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */
class Solution {
public:
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        // assume the node exists in the tree
        if(!root || root == p || root == q) return root;

        TreeNode* left = lowestCommonAncestor(root->left, p, q);
        TreeNode* right = lowestCommonAncestor(root->right, p, q);
        // there must be three cases {left, right, root} contains CLA
        return !left? right: !right ? left: root;
    }
};
```

**Code \(Python\)**

```py
 # Definition for a binary tree node.
# class TreeNode(object):
#     def __init__(self, x):
#         self.val = x
#         self.left = None
#         self.right = None

class Solution(object):
    def lowestCommonAncestor(self, root, p, q):
        """
        :type root: TreeNode
        :type p: TreeNode
        :type q: TreeNode
        :rtype: TreeNode
        """
        if root in (None, p , q): return root

        left, right = (self.lowestCommonAncestor(child, p, q) 
                   for child in (root.left, root.right));

        return root if left and right else left or right
        
        //subs = [self.lowestCommonAncestor(kid, p, q)
        //        for kid in (root.left, root.right)] // None is considered smaller than any node:
        // return root if all(subs) else max(subs)
```

Special Thanks for [StefanPochmann](https://discuss.leetcode.com/user/stefanpochmann) for providing such a cool, condensed solution!

