# 107. Binary Tree Level Order Traversal II

Given a binary tree, return thebottom-up level ordertraversal of its nodes' values. \(ie, from left to right, level by level from leaf to root\).

For example:  
Given binary tree`[3,9,20,null,null,15,7]`,

```
    3
   / \
  9  20
    /  \
   15   7
```

return its bottom-up level order traversal as:

```
[
  [15,7],
  [9,20],
  [3]
]
```

**Thoughts: BFS + Adding in front \(vector insert / deque push\_front\)**

```cpp
/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */
class Solution {
    vector<vector<int>> answer;
public:
    vector<vector<int>> levelOrderBottom(TreeNode* root) {
        queue<TreeNode*> q;
        q.push(root);

        while(!q.empty()){
            int len = q.size();
            vector<int> level;
            for(int i = 0 ; i < len; i++){
                TreeNode * curNode = q.front(); q.pop();
                if(!curNode) continue; 
                level.push_back(curNode->val);
                q.push(curNode->left);
                q.push(curNode->right);
            }

                if(!level.empty()) answer.insert(answer.begin(),level);
        }

        return answer;
    }
};
```



