# **480. Sliding Window Median **

Median is the middle value in an ordered integer list. If the size of the list is even, there is no middle value. So the median is the mean of the two middle value.

Examples:

`[2,3,4]`, the median is`3`

`[2,3]`, the median is`(2 + 3) / 2 = 2.5`

Given an array _nums_, there is a sliding window of size _k \_which is moving from the very left of the array to the very right. You can only see the k_ numbers in the window. Each time the sliding window moves right by one position. Your job is to output the median array for each window in the original array.

For example,  
Givennums=`[1,3,-1,-3,5,3,6,7]`, andk= 3.

```
Window position                Median
---------------               -----
[1  3  -1] -3  5  3  6  7       1
 1 [3  -1  -3] 5  3  6  7       -1
 1  3 [-1  -3  5] 3  6  7       -1
 1  3  -1 [-3  5  3] 6  7       3
 1  3  -1  -3 [5  3  6] 7       5
 1  3  -1  -3  5 [3  6  7]      6
```

Therefore, return the median sliding window as`[1,-1,-1,3,5,6]`.

**Thoughts:**

Keep the window elements in a multiset and keep an iterator pointing to the middle value \(to “index” k/2, to be precise\).

**Code**

```cpp
class Solution {
public:
    vector<double> medianSlidingWindow(vector<int>& nums, int k) {
        multiset<int> window(nums.begin(), nums.begin() + k);
        auto mid = next(window.begin(), k/2);
        vector<double> medians;

        for(int i = k; ; i++){
            // push current median
            medians.push_back((double(*mid) + *prev(mid, 1 - k%2))/2);

            if(i == nums.size()) return medians;

            window.insert(nums[i]);
            if(nums[i] < *mid) mid --; // no equal here because if inserted value is equal to that of mid, the newly 
            // inserted one actually comes AFTER the mid. 

            if(nums[i-k] <= *mid) mid++;
            window.erase(window.lower_bound(nums[i-k]));
        }
    }
};
```

Special Thanks to [stefanpochmann](https://leetcode.com/stefanpochmann)'s [repost ](https://leetcode.com/problems/sliding-window-median/discuss/96340)from [@votrubac’s solution and comments](https://discuss.leetcode.com/topic/74739/c-95-ms-single-multiset-o-n-log-n).

