# 237. Delete Node in a Linked List

Write a function to delete a node \(except the tail\) in a singly linked list, **given only access to that node**.

Supposed the linked list is`1 -> 2 -> 3 -> 4`and you are given the third node with value`3`, the linked list should become`1 -> 2 -> 4`after calling your function.

**Thoughts:**

1. Copy the **node value **of the next node to the **current node**
2. Optional: free the next node

**Code**

```cpp
/**
 * Definition for singly-linked list.
 * struct ListNode {
 *     int val;
 *     ListNode *next;
 *     ListNode(int x) : val(x), next(NULL) {}
 * };
 */
class Solution {
public:
    void deleteNode(ListNode* node) {
        *node = *node->next;
    }
};
```

**Code \(freeing space\)**

```cpp
/**
 * Definition for singly-linked list.
 * struct ListNode {
 *     int val;
 *     ListNode *next;
 *     ListNode(int x) : val(x), next(NULL) {}
 * };
 */
class Solution {
public:
    void deleteNode(ListNode* node) {
        auto next = node -> next;
        *node = *next;
        delete next;
    }
};
```

**Code \(Java / C\#\)**

```
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode(int x) { val = x; }
 * }
 */
class Solution {
    public void deleteNode(ListNode node) {
        node.val = node.next.val;
        node.next = node.next.next;
    }
}
```

**Code \(Python\)**

```
# Definition for singly-linked list.
# class ListNode(object):
#     def __init__(self, x):
#         self.val = x
#         self.next = None

class Solution(object):
    def deleteNode(self, node):
        """
        :type node: ListNode
        :rtype: void Do not return anything, modify node in-place instead.
        """
        node.val = node.next.val;
        node.next= node.next.next;
```

**Code \(JavaScript\)**

```js
var deleteNode = function(node) {
    node.val = node.next.val;
    node.next = node.next.next;
};
```

**Code \(Ruby\)**

```ruby
# Definition for singly-linked list.
# class ListNode
#     attr_accessor :val, :next
#     def initialize(val)
#         @val = val
#         @next = nil
#     end
# end

# @param {ListNode} node
# @return {Void} Do not return anything, modify node in-place instead.
def delete_node(node)
    node.val = node.next.val;
    node.next = node.next.next;
end
```

Special Thanks to [stefanpochmann](https://leetcode.com/stefanpochmann)'s [solution ](https://leetcode.com/problems/delete-node-in-a-linked-list/discuss/65455)for the reference

