### 48. Rotate Image

You are given annxn2D matrix representing an image.

Rotate the image by 90 degrees \(clockwise\).

**Note:**  
You have to rotate the image**in-place**, which means you have to modify the input 2D matrix directly.**DO NOT**allocate another 2D matrix and do the rotation.

**Example 1:**

```
Given 
input matrix
 = 
[
  [1,2,3],
  [4,5,6],
  [7,8,9]
],

rotate the input matrix 
in-place
 such that it becomes:
[
  [7,4,1],
  [8,5,2],
  [9,6,3]
]
```

**Example 2:**

```
Given 
input matrix
 =
[
  [ 5, 1, 9,11],
  [ 2, 4, 8,10],
  [13, 3, 6, 7],
  [15,14,12,16]
], 

rotate the input matrix 
in-place
 such that it becomes:
[
  [15,13, 2, 5],
  [14, 3, 4, 1],
  [12, 6, 8, 9],
  [16, 7,10,11]
]
```

**\[Thoughts\]**

两种常用解法，建议用第二种，快，简洁，好记

**\[Code1: **[**Figure out the correct corresponding index and i,j range in the for loop**](https://www.jiuzhang.com/solution/rotate-image/)**\]**

```cpp
class Solution {
    int n;
public:
    void rotate(vector<vector<int>>& matrix) {
        if (matrix.size() == 0) return;
        n = matrix.size();

        for (int i = 0; i < (n+1)/2; i++ ){
            for (int j = 0; j < n/2 ; j++){
                // here i and j only needs one to be (n+1)/2 and the other be n/2
                // [i,j] -> [j][n-1-i] -> [n-1-i][n-1-j]->[n-1-j][i] 
                //   ^                                        |
                //   |----------------------------------------|
                int temp = matrix[j][n-1-i]; // who is the temp does not matter
                matrix[j][n-1-i] = matrix[i][j];
                matrix[i][j] = matrix[n-1-j][i];
                matrix[n-1-j][i] = matrix[n-1-i][n-1-j];
                matrix[n-1-i][n-1-j] = temp;
            }
        }
    }
};
```

**\[Code2: **[**reverse up down + swap symmetry**](https://discuss.leetcode.com/topic/6796/a-common-method-to-rotate-the-image)** \(Recommend\)\]**

```cpp
/*
 * clockwise rotate
 * first reverse up to down, then swap the symmetry 
 * 1 2 3     7 8 9     7 4 1
 * 4 5 6  => 4 5 6  => 8 5 2
 * 7 8 9     1 2 3     9 6 3
*/
void rotate(vector<vector<int> > &matrix) {
    reverse(matrix.begin(), matrix.end());
    for (int i = 0; i < matrix.size(); ++i) {
        for (int j = i + 1; j < matrix[i].size(); ++j)
            swap(matrix[i][j], matrix[j][i]);
    }
}
```

**Extension: **[**counter-clockwise**](https://discuss.leetcode.com/topic/6796/a-common-method-to-rotate-the-image): reverse left to right + swap the symmetry

```cpp
/*
 * anticlockwise rotate
 * first reverse left to right, then swap the symmetry
 * 1 2 3     3 2 1     3 6 9
 * 4 5 6  => 6 5 4  => 2 5 8
 * 7 8 9     9 8 7     1 4 7
*/
void anti_rotate(vector<vector<int> > &matrix) {
    for (auto vi : matrix) reverse(vi.begin(), vi.end());
    for (int i = 0; i < matrix.size(); ++i) {
        for (int j = i + 1; j < matrix[i].size(); ++j)
            swap(matrix[i][j], matrix[j][i]);
    }
}
```



